SystemOrganization addCategory: #'SmalltalkHub-Models-Core'!
SystemOrganization addCategory: #'SmalltalkHub-Models-Wikis'!
SystemOrganization addCategory: #'SmalltalkHub-Models-Entities'!
SystemOrganization addCategory: #'SmalltalkHub-Models-Projects'!
SystemOrganization addCategory: #'SmalltalkHub-Models-Timelines'!

Object subclass: #ShObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkHub-Models-Core'!

ShObject subclass: #ShCodeRepository
	instanceVariableNames: 'packages project acl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkHub-Models-Projects'!

!ShCodeRepository class methodsFor: 'instance creation' stamp: 'NicolasPetton 2/23/2011 17:23'!
on: aProject
	^self new 
		project: aProject; 
		yourself! !

!ShCodeRepository methodsFor: 'access rights' stamp: 'NicolasPetton 2/23/2011 17:56'!
acl
	^acl ifNil: [acl := Dictionary new]! !

!ShCodeRepository methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 17:36'!
addPackage: aPackage
	self packages add: aPackage! !

!ShCodeRepository methodsFor: 'access rights' stamp: 'NicolasPetton 2/17/2011 14:08'!
allAccessors
	"Empty means all!!"
	^(self acl at: #access ifAbsent: [#()]) asOrderedCollection! !

!ShCodeRepository methodsFor: 'accessing' stamp: 'NicolasPetton 2/24/2011 18:17'!
allPackagesNamed: aString
	^(self packages select: [:each | each name = aString]) 	
		asSortedCollection: [:p1 :p2 | p1 timestamp > p2 timestamp]! !

!ShCodeRepository methodsFor: 'access rights' stamp: 'NicolasPetton 2/17/2011 14:08'!
allUpdators
	"Empty means all!!"
	^(self acl at: #update ifAbsent: [#()]) asOrderedCollection! !

!ShCodeRepository methodsFor: 'access rights' stamp: 'NicolasPetton 2/17/2011 14:19'!
allowAccessTo: anUser
	| acls |
	acls := self acl at: #access ifAbsentPut: [Set new].
	acls add: anUser! !

!ShCodeRepository methodsFor: 'access rights' stamp: 'NicolasPetton 2/17/2011 14:08'!
allowAccessToAll
	self acl removeKey: #access ifAbsent: []! !

!ShCodeRepository methodsFor: 'access rights' stamp: 'NicolasPetton 2/17/2011 14:18'!
allowUpdateTo: anUser
	| acls |
	acls := self acl at: #update ifAbsentPut: [Set new].
	acls add: anUser! !

!ShCodeRepository methodsFor: 'access rights' stamp: 'NicolasPetton 2/17/2011 14:08'!
allowUpdateToAll
	self acl removeKey: #update ifAbsent: []! !

!ShCodeRepository methodsFor: 'authentification' stamp: 'NicolasPetton 2/23/2011 17:31'!
authenticateUser: anUsername password: aPassword
	^(ShUser 
		find: [:each | 
			each username = anUsername and: [each password = aPassword]]
		ifAbsent: [nil])! !

!ShCodeRepository methodsFor: 'authentification' stamp: 'NicolasPetton 2/17/2011 14:08'!
authenticateUserFromRequest: aRequest
	| userid password |
	(aRequest headers includesFieldNamed: 'AUTHORIZATION')
		ifFalse: [^nil].
	userid := (aRequest headers fieldNamed: 'AUTHORIZATION') userid.
	password := (aRequest headers fieldNamed: 'AUTHORIZATION') password.
	^self authenticateUser: userid password: password! !

!ShCodeRepository methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 18:18'!
directory
	^FSDiskFilesystem current working / 'mc' / self project owner name / self project title! !

!ShCodeRepository methodsFor: 'access rights' stamp: 'NicolasPetton 2/17/2011 14:19'!
disallowAccessTo: anUser
	| acls |
	acls := self acl at: #access ifAbsentPut: [Set new].
	acls remove: anUser ifAbsent: []! !

!ShCodeRepository methodsFor: 'access rights' stamp: 'NicolasPetton 2/17/2011 14:19'!
disallowUpdateTo: anUser
	| acls |
	acls := self acl at: #update ifAbsentPut: [Set new].
	acls remove: anUser ifAbsent: []! !

!ShCodeRepository methodsFor: 'testing' stamp: 'NicolasPetton 2/17/2011 14:23'!
isAccessAllowedFor: anUser
	| acls |
	acls := self acl at: #access ifAbsent: [^true].
	acls isEmpty ifTrue: [^true].
	(acls includes: anUser) ifTrue: [^true].
	^acls contains: [:each | each isGroup and: [each includes: anUser]]
	! !

!ShCodeRepository methodsFor: 'testing' stamp: 'NicolasPetton 2/23/2011 17:33'!
isUpdateAllowedFor: anUser
	| acls |
	acls := self acl at: #update ifAbsent: [^true].
	acls isEmpty ifTrue: [^true].
	(acls includes: anUser) ifTrue: [^true].
	^acls contains: [:each | each isGroup and: [each includes: anUser]]
	! !

!ShCodeRepository methodsFor: 'accessing' stamp: 'NicolasPetton 2/17/2011 14:08'!
packageNamed: aString
	^self packagesByName detect: [:each |
		each name = aString] ifNone: [^nil]! !

!ShCodeRepository methodsFor: 'accessing' stamp: 'NicolasPetton 2/17/2011 14:08'!
packages
	packages isNil ifTrue: [packages := OrderedCollection new].
	^packages! !

!ShCodeRepository methodsFor: 'accessing' stamp: 'NicolasPetton 2/24/2011 19:56'!
packagesByName
	| pkgs |
	pkgs := Dictionary new.
	self packages do: [:each |
		pkgs 
			at: each version package name 
			ifPresent: [:pkg |
				((pkg version info timeStamp) < (each version info timeStamp)) ifTrue: [
					pkgs at: each version package name put: each]].
		pkgs at: each version package name ifAbsentPut: [each]].
	^pkgs! !

!ShCodeRepository methodsFor: 'accessing' stamp: 'NicolasPetton 2/24/2011 17:57'!
project
	^project! !

!ShCodeRepository methodsFor: 'accessing' stamp: 'NicolasPetton 2/24/2011 17:58'!
project: aProject
	project := aProject! !

!ShCodeRepository methodsFor: 'accessing' stamp: 'NicolasPetton 2/28/2011 16:22'!
versionNamed: aString
	^self packages 
		detect: [:each | each version info name = aString]
		ifNone: [nil]! !

!ShObject methodsFor: 'testing' stamp: 'NicolasPetton 2/17/2011 14:24'!
isGroup
	^false! !

!ShObject methodsFor: 'testing' stamp: 'NicolasPetton 2/17/2011 14:24'!
isUser
	^false! !

!ShObject methodsFor: 'accessing' stamp: 'NicolasPetton 2/24/2011 22:15'!
path
	^nil! !

ShObject subclass: #ShPackage
	instanceVariableNames: 'parent version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkHub-Models-Projects'!

!ShPackage class methodsFor: 'instance creation' stamp: 'NicolasPetton 2/24/2011 18:10'!
on: aCodeRepository file: aFile
	^self basicNew
		parent: aCodeRepository;
		initializeFromFile: aFile;
		initialize;
		yourself! !

!ShPackage methodsFor: 'initialization' stamp: 'NicolasPetton 2/24/2011 19:35'!
initializeFromFile: aFile
	version := (MCReader on: aFile pathString name: aFile basename) version! !

!ShPackage methodsFor: 'testing' stamp: 'NicolasPetton 2/17/2011 14:31'!
isAccessAllowedFor: anUser
	^self parent isAccessAllowedFor: anUser! !

!ShPackage methodsFor: 'accessing' stamp: 'NicolasPetton 2/28/2011 15:33'!
packageName
	^self version package name! !

!ShPackage methodsFor: 'accessing' stamp: 'NicolasPetton 2/17/2011 14:12'!
parent
	^parent! !

!ShPackage methodsFor: 'accessing' stamp: 'NicolasPetton 2/17/2011 14:12'!
parent: aCodeRepository
	parent := aCodeRepository ! !

!ShPackage methodsFor: 'accessing' stamp: 'NicolasPetton 2/17/2011 14:12'!
repository
	^self parent! !

!ShPackage methodsFor: 'accessing' stamp: 'NicolasPetton 2/24/2011 19:35'!
version
	^version! !

!ShPackage methodsFor: 'accessing' stamp: 'NicolasPetton 2/28/2011 15:32'!
versionName
	^self version info name! !

ShObject subclass: #ShTimelineEvent
	instanceVariableNames: 'owner project timestamp title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkHub-Models-Timelines'!

ShTimelineEvent subclass: #ShIssueTimelineEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkHub-Models-Timelines'!

!ShIssueTimelineEvent methodsFor: 'testing' stamp: 'NicolasPetton 2/23/2011 15:22'!
isIssueEvent
	^true! !

ShTimelineEvent subclass: #ShProjectTimelineEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkHub-Models-Timelines'!

ShProjectTimelineEvent subclass: #ShCommitTimelineEvent
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkHub-Models-Timelines'!

!ShCommitTimelineEvent methodsFor: 'testing' stamp: 'NicolasPetton 2/24/2011 14:52'!
isCommitEvent 
	^true! !

!ShCommitTimelineEvent methodsFor: 'accessing' stamp: 'NicolasPetton 2/24/2011 14:45'!
package
	^ package! !

!ShCommitTimelineEvent methodsFor: 'accessing' stamp: 'NicolasPetton 2/24/2011 14:45'!
package: aPackage
	package := aPackage! !

!ShProjectTimelineEvent methodsFor: 'testing' stamp: 'NicolasPetton 2/23/2011 15:22'!
isProjectEvent
	^true! !

!ShTimelineEvent methodsFor: 'adding/removing' stamp: 'NicolasPetton 2/22/2011 15:17'!
addTo: anUser
	anUser addTimelineEvent: self! !

!ShTimelineEvent methodsFor: 'testing' stamp: 'NicolasPetton 2/24/2011 14:51'!
isCommitEvent
	^false! !

!ShTimelineEvent methodsFor: 'testing' stamp: 'NicolasPetton 2/23/2011 00:16'!
isIssueEvent
	^false! !

!ShTimelineEvent methodsFor: 'testing' stamp: 'NicolasPetton 2/23/2011 00:16'!
isProjectEvent
	^false! !

!ShTimelineEvent methodsFor: 'testing' stamp: 'NicolasPetton 2/23/2011 00:16'!
isUserEvent
	^false! !

!ShTimelineEvent methodsFor: 'testing' stamp: 'NicolasPetton 2/23/2011 00:16'!
isWikiEvent
	^false! !

!ShTimelineEvent methodsFor: 'accessing' stamp: 'NicolasPetton 2/22/2011 13:22'!
owner
	^ owner! !

!ShTimelineEvent methodsFor: 'accessing' stamp: 'NicolasPetton 2/22/2011 13:22'!
owner: anUser
	owner := anUser
! !

!ShTimelineEvent methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 15:23'!
project
	^ project! !

!ShTimelineEvent methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 15:23'!
project: aProject
	project := aProject! !

!ShTimelineEvent methodsFor: 'accessing' stamp: 'NicolasPetton 2/22/2011 13:23'!
setTimestamp
	timestamp := TimeStamp now! !

!ShTimelineEvent methodsFor: 'accessing' stamp: 'NicolasPetton 2/22/2011 13:22'!
timestamp
	^ timestamp! !

!ShTimelineEvent methodsFor: 'accessing' stamp: 'NicolasPetton 2/22/2011 13:22'!
title
	^ title! !

!ShTimelineEvent methodsFor: 'accessing' stamp: 'NicolasPetton 2/22/2011 13:23'!
title: aString
	title := aString! !

ShTimelineEvent subclass: #ShUserTimelineEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkHub-Models-Timelines'!

!ShUserTimelineEvent methodsFor: 'testing' stamp: 'NicolasPetton 2/23/2011 15:22'!
isUserEvent 
	^true! !

ShTimelineEvent subclass: #ShWikiTimelineEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkHub-Models-Timelines'!

!ShWikiTimelineEvent methodsFor: 'testing' stamp: 'NicolasPetton 2/23/2011 15:22'!
isWikiEvent 
	^true! !

SDActiveRecord subclass: #ShActiveRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkHub-Models-Core'!

!ShActiveRecord methodsFor: 'testing' stamp: 'NicolasPetton 2/22/2011 15:14'!
isGroup
	^false! !

!ShActiveRecord methodsFor: 'testing' stamp: 'NicolasPetton 2/22/2011 15:14'!
isUser
	^false! !

!ShActiveRecord methodsFor: 'accessing' stamp: 'NicolasPetton 2/24/2011 22:14'!
path
	^nil! !

ShActiveRecord subclass: #ShEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkHub-Models-Entities'!

!ShEntity methodsFor: 'accessing' stamp: 'NicolasPetton 2/18/2011 10:56'!
name
	self subclassResponsibility ! !

!ShEntity methodsFor: 'accessing' stamp: 'SebastienAudier 2/22/2011 10:57'!
projects
	^ ShProject findAll: [:each | each owner = self]! !

ShEntity subclass: #ShGroup
	instanceVariableNames: 'name users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkHub-Models-Entities'!

!ShGroup methodsFor: 'testing' stamp: 'NicolasPetton 2/18/2011 10:59'!
isGroup
	^true! !

!ShGroup methodsFor: 'accessing' stamp: 'NicolasPetton 2/18/2011 10:53'!
name
	^ name
! !

!ShGroup methodsFor: 'accessing' stamp: 'NicolasPetton 2/18/2011 10:53'!
name: aString
	name := aString
! !

!ShGroup methodsFor: 'accessing' stamp: 'NicolasPetton 2/18/2011 10:53'!
users
	^ users ifNil: [users := OrderedCollection new]
! !

!ShGroup methodsFor: 'accessing' stamp: 'NicolasPetton 2/18/2011 10:52'!
users: anObject
	users := anObject! !

ShEntity subclass: #ShUser
	instanceVariableNames: 'email username password website bio following timelineEvents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkHub-Models-Entities'!

!ShUser commentStamp: '<historical>' prior: 0!
I represent an user of SmalltalkHub.

Instance Variables:
	email	<ProtoObject | PseudoContext>
	firstName	<ProtoObject | PseudoContext>
	lastName	<ProtoObject | PseudoContext>
	password	<ProtoObject | PseudoContext>
	projects	<OrderedCollection>!

!ShUser methodsFor: 'adding/removing' stamp: 'NicolasPetton 2/23/2011 14:36'!
addTimelineEvent: aTimelineEvent
	self timelineEvents size > self timelineEventsMaxSize ifTrue: [
		self timelineEvents removeLast].
	self timelineEvents addFirst: aTimelineEvent! !

!ShUser methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 14:33'!
allTimelineEvents
	| allEvents |
	allEvents := OrderedCollection new.
	allEvents addAll: self timelineEvents.
	self following do: [:each |
		allEvents addAll: each timelineEvents].
	^allEvents! !

!ShUser methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 11:45'!
bio
	^bio ifNil: ['']! !

!ShUser methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 11:44'!
bio: aString
	bio := aString! !

!ShUser methodsFor: 'accessing' stamp: 'NicolasPetton 2/17/2011 14:05'!
email
	^ email! !

!ShUser methodsFor: 'accessing' stamp: 'NicolasPetton 2/17/2011 14:06'!
email: aString
	email := aString! !

!ShUser methodsFor: 'adding/removing' stamp: 'NicolasPetton 2/23/2011 14:01'!
follow: aProject
	self following add: aProject! !

!ShUser methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 14:01'!
following
	^following ifNil: [following := OrderedCollection new]! !

!ShUser methodsFor: 'testing' stamp: 'NicolasPetton 2/23/2011 14:02'!
isFollowing: aProject
	^self following includes: aProject! !

!ShUser methodsFor: 'testing' stamp: 'NicolasPetton 2/17/2011 14:24'!
isUser
	^true! !

!ShUser methodsFor: 'accessing' stamp: 'NicolasPetton 2/21/2011 11:10'!
name
	^self username! !

!ShUser methodsFor: 'accessing' stamp: 'NicolasPetton 2/17/2011 14:05'!
password
	^ password! !

!ShUser methodsFor: 'accessing' stamp: 'NicolasPetton 2/17/2011 14:06'!
password: aString
	password := aString! !

!ShUser methodsFor: 'accessing' stamp: 'NicolasPetton 2/22/2011 23:22'!
timelineEvents
	^timelineEvents ifNil: [timelineEvents := OrderedCollection new]! !

!ShUser methodsFor: 'accessing' stamp: 'NicolasPetton 2/22/2011 23:22'!
timelineEventsMaxSize 
	^50! !

!ShUser methodsFor: 'adding/removing' stamp: 'NicolasPetton 2/23/2011 14:01'!
unfollow: aProject
	self following remove: aProject! !

!ShUser methodsFor: 'accessing' stamp: 'NicolasPetton 2/19/2011 22:54'!
username
	^ username! !

!ShUser methodsFor: 'accessing' stamp: 'NicolasPetton 2/19/2011 22:54'!
username: aString
	username := aString! !

!ShUser methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 11:45'!
website
	^website ifNil: ['']! !

!ShUser methodsFor: 'accessing' stamp: 'NicolasPetton 2/19/2011 22:57'!
website: aString
	website := aString! !

ShActiveRecord subclass: #ShLicense
	instanceVariableNames: 'title url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkHub-Models-Projects'!

!ShLicense methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 09:39'!
title
	^ title! !

!ShLicense methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 09:39'!
title: aString
	title := aString
! !

!ShLicense methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 09:42'!
url
	^ url! !

!ShLicense methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 09:42'!
url: aString
	url := aString
! !

ShActiveRecord subclass: #ShProject
	instanceVariableNames: 'title website projectDescription license tags followers owner repository wiki issues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkHub-Models-Projects'!

!ShProject methodsFor: 'accessing' stamp: 'NicolasPetton 2/24/2011 14:54'!
commitEvents
	^self timelineEvents select: [:each |
		each isCommitEvent]! !

!ShProject methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 10:40'!
followers
	^ShUser findAll: [:each |
		each isFollowing: self]! !

!ShProject methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 09:47'!
license
	^license! !

!ShProject methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 09:48'!
license: aLicense
	license := aLicense! !

!ShProject methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 22:30'!
mcRepositoryPath
	^'/', ShSmalltalkHubSettings instance mcDirectory, self owner path, '/', self title! !

!ShProject methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 22:27'!
mcRepositoryUrl 
	^ShSmalltalkHubSettings instance hostname, self mcRepositoryPath ! !

!ShProject methodsFor: 'accessing' stamp: 'NicolasPetton 2/17/2011 14:11'!
owner
	^ owner! !

!ShProject methodsFor: 'accessing' stamp: 'NicolasPetton 2/17/2011 14:11'!
owner: anUser
	owner := anUser
! !

!ShProject methodsFor: 'accessing' stamp: 'NicolasPetton 2/22/2011 23:02'!
projectDescription
	^ projectDescription
! !

!ShProject methodsFor: 'accessing' stamp: 'NicolasPetton 2/22/2011 23:02'!
projectDescription: aString
	projectDescription := aString
! !

!ShProject methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 17:23'!
repository
	^ repository ifNil: [repository := ShCodeRepository on: self]! !

!ShProject methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 10:18'!
tags
	^tags ifNil: [tags := OrderedCollection new]! !

!ShProject methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 10:19'!
tags: aCollection
	tags := aCollection! !

!ShProject methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 15:23'!
timelineEvents 
	^self owner timelineEvents select: [:each |
		each project = self]! !

!ShProject methodsFor: 'accessing' stamp: 'SebastienAudier 2/22/2011 11:06'!
title
	^ title! !

!ShProject methodsFor: 'accessing' stamp: 'SebastienAudier 2/22/2011 11:06'!
title: aString
	title := aString
! !

!ShProject methodsFor: 'accessing' stamp: 'SebastienAudier 2/22/2011 11:06'!
website
	^ website! !

!ShProject methodsFor: 'accessing' stamp: 'SebastienAudier 2/22/2011 11:06'!
website: aString
	website := aString
! !

!ShProject methodsFor: 'accessing' stamp: 'NicolasPetton 2/18/2011 11:06'!
wiki
	^wiki ifNil: [wiki := ShWiki new]! !

ShActiveRecord subclass: #ShSmalltalkHubSettings
	instanceVariableNames: 'tags mcRepositoryUrl mcDirectory hostname'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkHub-Models-Core'!

!ShSmalltalkHubSettings class methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 10:13'!
instance
	^self 
		find: [:each | true] 
		ifAbsent: [self new save; yourself]! !

!ShSmalltalkHubSettings methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 10:11'!
addTag: aString
	(self tags includes: aString) ifFalse: [
		self tags add: aString]! !

!ShSmalltalkHubSettings methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 22:26'!
hostname
	^ hostname! !

!ShSmalltalkHubSettings methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 22:27'!
hostname: aString
	hostname := aString
! !

!ShSmalltalkHubSettings methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 22:26'!
mcDirectory 
	^mcDirectory ifNil: ['mc']! !

!ShSmalltalkHubSettings methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 22:26'!
mcDirectory: aString
	mcDirectory  := aString! !

!ShSmalltalkHubSettings methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 10:12'!
removeTag: aString
	(self tags includes: aString) ifTrue: [
		self tags remove: aString]! !

!ShSmalltalkHubSettings methodsFor: 'accessing' stamp: 'NicolasPetton 2/23/2011 10:11'!
tags
	^tags ifNil: [tags := OrderedCollection new]! !

ShActiveRecord subclass: #ShWiki
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkHub-Models-Wikis'!
